      SUBROUTINE CHERCHE_VOIS (NODE,IVOIS,NBVOIS,NEL)
      INTEGER NODE(8,*),IVOIS(26,*),NBVOIS(*),ILIST(4),JLIST(4)
C
      DO 10 I=1,NEL
        NBVOIS(I) = 0
        DO 20 J=1,26
          IVOIS(J,I) = 0
   20   CONTINUE
   10 CONTINUE
C
      DO 30 I=1,NEL
        DO 40 J=I+1,NEL
          CALL COMMUN(NODE(1,I),NODE(1,J),NB,ILIST,JLIST,8)
          IF (NB.NE.0) THEN
            IF (NB.EQ.1) THEN
              II = 18 + ILIST(1)
              JJ = 18 + JLIST(1)
            ELSEIF(NB.EQ.2) THEN
              IDIFF = IABS ( ILIST(1) - ILIST(2) )
              IF (IDIFF.EQ.1) THEN
                II = 6 + MIN ( ILIST(1) , ILIST(2) )
              ELSEIF (IDIFF.EQ.3) THEN
                II = 6 + MAX ( ILIST(1) , ILIST(2) )
              ELSE
                II = 12 + ( ILIST(1) + ILIST(2) ) / 2
              ENDIF
              JDIFF = IABS ( JLIST(1) - JLIST(2) )
              IF (JDIFF.EQ.1) THEN
                JJ = 6 + MIN ( JLIST(1) , JLIST(2) )
              ELSEIF (JDIFF.EQ.3) THEN
                JJ = 6 + MAX ( JLIST(1) , JLIST(2) )
              ELSE
                JJ = 12 + ( JLIST(1) + JLIST(2) ) / 2
              ENDIF
            ELSE
              NBVOIS(I) = NBVOIS(I) + 1
              NBVOIS(J) = NBVOIS(J) + 1
              IPROD = ILIST(1)*ILIST(2)*ILIST(3)*ILIST(4)
CC              IF (IPROD.GE.1680)    THEN
CC                II = 6
CC              ELSEIF (IPROD.GE.672) THEN 
CC                II = 4
CC              ELSEIF (IPROD.GE.252) THEN 
CC                II = 2
CC              ELSEIF (IPROD.GE.160) THEN
CC                II = 1             
CC              ELSEIF (IPROD.GE.60)  THEN
CC                II = 3
CC              ELSE
CC                II = 5
CC              ENDIF
              IF (IPROD.GE.252)    THEN
                IF (IPROD.GE.1680)    THEN
                  II = 6
                ELSEIF (IPROD.GE.672) THEN 
                  II = 4
                ELSE
                  II = 2
                ENDIF
              ELSE
                IF (IPROD.GE.160) THEN
                  II = 1             
                ELSEIF (IPROD.GE.60)  THEN
                  II = 3
                ELSE
                  II = 5
                ENDIF
              ENDIF
C
              JPROD = JLIST(1)*JLIST(2)*JLIST(3)*JLIST(4)
CC              IF (JPROD.GE.1680)    THEN
CC                JJ = 6
CC              ELSEIF (JPROD.GE.672) THEN 
CC                JJ = 4
CC              ELSEIF (JPROD.GE.252) THEN 
CC                JJ = 2
CC              ELSEIF (JPROD.GE.160) THEN
CC                JJ = 1             
CC              ELSEIF (JPROD.GE.60)  THEN
CC                JJ = 3
CC              ELSE
CC                JJ = 5
CC              ENDIF
              IF (JPROD.GE.252)    THEN
                IF (JPROD.GE.1680)    THEN
                  JJ = 6
                ELSEIF (JPROD.GE.672) THEN 
                  JJ = 4
                ELSE
                  JJ = 2
                ENDIF
              ELSE
                IF (JPROD.GE.160) THEN
                  JJ = 1             
                ELSEIF (JPROD.GE.60)  THEN
                  JJ = 3
                ELSE
                  JJ = 5
                ENDIF
              ENDIF
C
            ENDIF
            IVOIS(II,I) = J
            IVOIS(JJ,J) = I
          ENDIF
   40   CONTINUE
   30 CONTINUE
C        
      END
